/******************************************* Start of Timer Code *****************************************/
var slideProgress;
var totalSlides = 107;
var myProgress = [];
var questionAsked = false;

var netConnected;
var gSlide, res, cSlide, csTo, csFrom, csTotal;

var thisTime, mm, ss;
var myPause = 0;

for ( var i = 0; i < totalSlides; i++ )
{
	myProgress[i] = 0;
}

function getConnected()
{
	if ( window.location.href.indexOf("http") == 0 )
	{
		return true;
	}
	else
	{
		return false;
	}
}

function supports_html5_storage() 
{
	if ( typeof(Storage) !== "undefined" ) 
	{
		 return true;
	} 
	else 
	{
		return false;
	}
}

if ( getConnected() )
{
	if ( supports_html5_storage() )
	{	
		if ( localStorage.getItem( "slideProgress" ) === null ) 
		{
			localStorage.setItem( "slideProgress", 1 );	
		}
		else
		{
			slideProgress = Number( localStorage.getItem("slideProgress") );
			
			for ( var i = 0; i < slideProgress; i++ )
			{
				myProgress[i] = 1;
			}
		}
	}
	else
	{
		alert("Your browser does not support local storage, your progress in this course cannot be saved.")
	}
}

var interfaceObj;
var eventEmitterObj;

window.addEventListener("moduleReadyEvent", function(evt)
{
	interfaceObj = evt.Data;
	eventEmitterObj = interfaceObj.getEventEmitter();
    initializeEventListeners();
}); 

function initializeEventListeners()
{
	if ( interfaceObj )
	{
    	if ( eventEmitterObj )
		{
        	eventEmitterObj.addEventListener("CPAPI_SLIDEENTER",function(e){			
			setPage();
            });
		}
	}
}

function setPage()
{	
	window.cpCmndResume = 1;
	
	if ( slideProgress > 0 && questionAsked == false )
	{
		questionAsked = true;
		window.cpCmndPause = 1;
		
		swal({
			title: "AB1825 Message",
			text: "Would you like to return to your previous location?",
			showCancelButton: true,
			confirmButtonColor: "#6086b9",
			confirmButtonText: "Yes",
			cancelButtonText: "Cancel",
			closeOnConfirm: true,
			closeOnCancel: true,
			animation: "slide-from-top",
		}, function( isConfirm ) 
		{
			if ( isConfirm ) 
			{
				var projectSlides = cp.model.data.project_main.slides;
				var slidesArray = projectSlides.split(",");
				var jumpSlide = slidesArray[slideProgress];
				var res = jumpSlide.replace("Slide", ""); 
				window.cpCmndGotoSlideByUIDAndResume = res;
			} 
			else 
			{
				window.cpCmndResume = 1;
			}
		});       
	}
	else
	{
		questionAsked = true;
	}
	
	window.mcFeedback = "";
	window.tfFeedback = "";
	
	
		
	if ( myProgress[(window.cpInfoCurrentSlide - 1)] == 0 )
	{
		cp.hide( "next_"+window.cpInfoCurrentSlide );
	}
	else
	{
		cp.show( "next_"+window.cpInfoCurrentSlide );
	}
	
	gSlide = cp.model.data.project_main.slides;
	res = gSlide.split(",");
	cSlide = res[window.cpInfoCurrentSlide - 1];
	csTo = eval('cp.model.data.'+cSlide+'.to');
	csFrom = eval('cp.model.data.'+cSlide+'.from');
	csTotal =  csTo - csFrom;
	sf = window.cpInfoCurrentFrame;
	
	window.cpAPIEventEmitter.addEventListener("CPAPI_VARIABLEVALUECHANGED",function(){
			runTimer(csTotal, sf, csTo);},"cpInfoCurrentFrame");	
}

function runTimer(st, sf, ef)
{		
	thisTime = Math.round((st - (window.cpInfoCurrentFrame - sf) - 1) / 30);
	mm = Math.floor(thisTime % 3600 / 60);
	ss = Math.floor(thisTime % 3600 % 60);
	newTime = ((mm > 0 ? (mm < 10 ? "0" : "") + mm + ":" : "00:") + (ss < 10 ? "0" : "") + ss);
	
	window.myTime = String(newTime);
	
	if ( mm == 0 && ss < 1 )
	{
		cp.show("next_"+window.cpInfoCurrentSlide);
		window.cpAPIEventEmitter.removeEventListener("CPAPI_VARIABLEVALUECHANGED",function(){
			runTimer(csTotal, sf, csTo);},"cpInfoCurrentFrame");
		
		if ( myProgress[(window.cpInfoCurrentSlide - 1)] == 0 )
		{
			myProgress[(window.cpInfoCurrentSlide - 1)] = 1;
			localStorage.setItem("slideProgress", window.cpInfoCurrentSlide);
		}
	}
}

/******************************************* End of Timer Code *****************************************/
var quizAnswers = [
	"True",
	"No",
	"No",
	"No",
	"d.  none of the above", //5
	"Yes",
	"d.  all of the above",
	"Yes",
	"Yes",
	"True", //10
	"Yes",
	"d.  exchanging sexual favors to keep your job",
	"c.  quid pro quo",
	"False",
	"c.  all of the above", //15
	"a.  Physical",
	"Yes",
	"True",
	"d.  all of the above",
	"True", //20
	"No",
	"Yes",
	"False",
	"True",
	"Yes", //25
	"False",
	"d.  all of the above",
	"False",
	"True",
	"False", //30
	"True",
	"No",
	"True",
	"a.  Strict liability",
	"True" //35
];

function checkAnswer(which)
{	
	if ( which == "" )
	{
		alert("You must make a selection")
	}
	else
	{	
		var qNum = which.split("_");
		var arrayNum = Number( qNum[1] );
		arrayNum--;
		
		var ca = eval( "window." + which );	
		
		if ( quizAnswers[arrayNum] == ca )
		{
			if ( window.cpInfoCurrentSlideLabel == "TF" || window.cpInfoCurrentSlideLabel == "MC" )
			{
				window.tfFeedback = "Correct. Please click the Next button to continue."
				cp.show("next_"+window.cpInfoCurrentSlide);
			}
		}
		else
		{
			if ( window.cpInfoCurrentSlideLabel == "TF" )
			{
				window.tfFeedback = "That's incorrect. Please click the Next button to continue.";
				cp.show("next_"+window.cpInfoCurrentSlide);
			}
			else if ( window.cpInfoCurrentSlideLabel == "MC" )
			{
				window.mcFeedback = "Sorry, that's incorrect. Please try again."
			}	
		}	
	}
}

//*************************** Button Functions ************************************//

function askInstructor()
{
	window.open("http://www.getsafetytrained.com/ContactUs.cfm");
}

function getRecord()
{
	cp.hide("pause_"+window.cpInfoCurrentSlide);
	alert("Training Record")
}

function getHelp()
{
	cp.jumpToNextSlide()

	//window.open("http://www.getsafetytrained.com/ContactUs.cfm");
}

//*************************** Misc Functions ************************************//

function getSlides()
{
	slideArray = cp.model.data.project_main.slides.split(',');
	
	for ( var i = 0; i < slideArray.length; i++ )
	{
		slideArray[i] = slideArray[i].replace('Slide','');		
	}
	
	return slideArray;
}